# This file was created automatically by SWIG.
import fluxc
from ooflib.SWIG.engine.fieldindex import IteratorPPtr
from ooflib.SWIG.engine.fieldindex import IndexPPtr
from ooflib.SWIG.engine.outputval import OutputValuePtr
class FluxPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def ndof(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_ndof,(self,) + _args, _kwargs)
        return val
    def divergence_dim(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_divergence_dim,(self,) + _args, _kwargs)
        return val
    def name(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_name,(self,) + _args, _kwargs)
        return val
    def objectid(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_objectid,(self,) + _args, _kwargs)
        return val
    def iterator(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_iterator,(self,) + _args, _kwargs)
        if val: val = IteratorPPtr(val) ; val.thisown = 1
        return val
    def iterator_all(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_iterator_all,(self,) + _args, _kwargs)
        if val: val = IteratorPPtr(val) ; val.thisown = 1
        return val
    def componenttype(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_componenttype,(self,) + _args, _kwargs)
        if val: val = IndexPPtr(val) ; val.thisown = 1
        return val
    def newOutputValue(self, *_args, **_kwargs):
        val = apply(fluxc.Flux_newOutputValue,(self,) + _args, _kwargs)
        if val: val = OutputValuePtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C Flux instance at %s>" % (self.this,)
class Flux(FluxPtr):
    def __init__(self,this):
        self.this = this




class VectorFluxPtr(FluxPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C VectorFlux instance at %s>" % (self.this,)
class VectorFlux(VectorFluxPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(fluxc.new_VectorFlux,_args,_kwargs)
        self.thisown = 1




class SymmetricTensorFluxPtr(FluxPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C SymmetricTensorFlux instance at %s>" % (self.this,)
class SymmetricTensorFlux(SymmetricTensorFluxPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(fluxc.new_SymmetricTensorFlux,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------

def getFluxByIndex(*_args, **_kwargs):
    val = apply(fluxc.getFluxByIndex,_args,_kwargs)
    return val

countFluxes = fluxc.countFluxes



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: flux.spy,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2010-12-05 05:06:21 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 

import types
from ooflib.common import debug
from ooflib.common import utils

FluxPtr.__repr__ = FluxPtr.name
SymmetricTensorFluxPtr.__repr__ = SymmetricTensorFluxPtr.name
VectorFluxPtr.__repr__ = VectorFluxPtr.name

def _Flux___hash__(self):
    return self.objectid()

FluxPtr.__hash__ = _Flux___hash__

def _Flux___cmp__(self, other):
    if not isinstance(other, FluxPtr): return -1
    if self.objectid() < other.objectid(): return -1
    if self.objectid() > other.objectid(): return 1
    return 0

FluxPtr.__cmp__ = _Flux___cmp__

class _AllFluxes:
    def __getitem__(self, indx):
        if type(indx) == types.IntType:
            if indx >= countFluxes():
                raise IndexError("Bad flux index: " + str(indx))
            return getFluxByIndex(indx)
        elif type(indx) == types.StringType:
            try:
                flx = utils.OOFeval(indx)
            except NameError:
                raise IndexError("Bad flux name: " + indx)
            if not isinstance(flx, FluxPtr):
                raise IndexError("Bad flux name: " + indx)
            return flx
##            for i in range(countFluxes()):
##                f = getFluxByIndex(i)
##                if f.name() == indx:
##                    return f
##            raise IndexError("Bad flux name: " + indx)
    def __len__(self):
        return countFluxes()

allFluxes = _AllFluxes()

def getFlux(which):
    return allFluxes[which]

utils.OOFdefine('getFlux', getFlux)
