# This file was created automatically by SWIG.
import meshdatacachec
class MeshDataCachePtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def setMesh(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_setMesh,(self,) + _args, _kwargs)
        return val
    def times(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_times,(self,) + _args, _kwargs)
        return val
    def size(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_size,(self,) + _args, _kwargs)
        return val
    def restore(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_restore,(self,) + _args, _kwargs)
        return val
    def restoreLatest(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_restoreLatest,(self,) + _args, _kwargs)
        return val
    def interpolate(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_interpolate,(self,) + _args, _kwargs)
        return val
    def record(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_record,(self,) + _args, _kwargs)
        return val
    def clear(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_clear,(self,) + _args, _kwargs)
        return val
    def latestTime(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_latestTime,(self,) + _args, _kwargs)
        return val
    def earliestTime(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_earliestTime,(self,) + _args, _kwargs)
        return val
    def transfer(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_transfer,(self,) + _args, _kwargs)
        return val
    def atLatest(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_atLatest,(self,) + _args, _kwargs)
        return val
    def atEarliest(self, *_args, **_kwargs):
        val = apply(meshdatacachec.MeshDataCache_atEarliest,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C MeshDataCache instance at %s>" % (self.this,)
class MeshDataCache(MeshDataCachePtr):
    def __init__(self,this):
        self.this = this




class MemoryDataCachePtr(MeshDataCachePtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,meshdatacachec=meshdatacachec):
        if self.thisown == 1 :
            meshdatacachec.delete_MemoryDataCache(self)
    def __repr__(self):
        return "<C MemoryDataCache instance at %s>" % (self.this,)
class MemoryDataCache(MemoryDataCachePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(meshdatacachec.new_MemoryDataCache,_args,_kwargs)
        self.thisown = 1




class DiskDataCachePtr(MeshDataCachePtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,meshdatacachec=meshdatacachec):
        if self.thisown == 1 :
            meshdatacachec.delete_DiskDataCache(self)
    def __repr__(self):
        return "<C DiskDataCache instance at %s>" % (self.this,)
class DiskDataCache(DiskDataCachePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(meshdatacachec.new_DiskDataCache,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: meshdatacache.spy,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2009-12-29 22:31:31 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from ooflib.common import enum
from ooflib.common import registeredclass
from ooflib.common.IO import oofmenu
from ooflib.engine import meshmod

class CacheType(enum.EnumClass(
        ('Memory', 'Store time steps in memory'),
        ('Disk', 'Store time steps in files'))):
    tip = "How to store data for previous time steps."


class SetMeshDataCacheType(meshmod.MeshModification):
    def __init__(self, cachetype):
        self.cachetype = cachetype
    def apply(self, meshcontext):
        if (self.cachetype == 'Memory' and 
            isinstance(meshcontext.datacache, DiskDataCache)):
            oldcache = meshcontext.datacache
            meshcontext.datacache = MemoryDataCache(meshcontext.getObject())
            meshcontext.datacache.transfer(oldcache)
        elif (self.cachetype == 'Disk' and
              isinstance(meshcontext.datacache, MemoryDataCache)):
            oldcache = meshcontext.datacache
            meshcontext.datacache = DiskDataCache(meshcontext.getObject())
            meshcontext.datacache.transfer(oldcache)
       
cacheTypeParam = enum.EnumParameter('cachetype', CacheType, value='Memory',
                           tip='Type of cache to use for time step data.')     
                                                     
dataCacheReg = registeredclass.Registration(
    'Set Data Cache Type',
    meshmod.MeshModification,
    SetMeshDataCacheType,
    ordering=10,
    params=[cacheTypeParam],
    tip='Choose to cache time step data in memory or on disk.')


def newMeshDataCache(femesh):
    if dataCacheReg.getParameter('cachetype').value == 'Memory':
        return MemoryDataCache(femesh)
    else:
        return DiskDataCache(femesh)

def getMeshDataCacheType(cache):
    if isinstance(cache, MemoryDataCache):
        return 'Memory'
    if isinstance(cache, DiskDataCache):
        return 'Disk'

###############

class ClearMeshDataCache(meshmod.MeshModification):
    def apply(self, meshcontext):
        meshcontext.clearDataCache()

registeredclass.Registration(
    'Clear Data Cache',
    meshmod.MeshModification,
    ClearMeshDataCache,
    ordering=11,
    tip='Remove cached field values for all times except the current time.')

