# This file was created automatically by SWIG.
import heatsourcec
from ooflib.SWIG.engine.properties import PropertyPtr
class HeatSourcePropPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C HeatSourceProp instance at %s>" % (self.this,)
class HeatSourceProp(HeatSourcePropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(heatsourcec.new_HeatSourceProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: heatsource.spy,v $
# $Revision: 1.4 $
# $Author: langer $
# $Date: 2010-11-10 22:34:16 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.


from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

PropertyRegistration = propertyregistration.PropertyRegistration

## Constant heat source

reg = PropertyRegistration(
    'Thermal:HeatSource:ConstantHeatSource', HeatSourceProp,
    "ooflib.SWIG.engine.property.heatsource.heatsource",150,
    [parameter.FloatParameter('rate', 0.0, tip="Rate of energy increase.")],
    propertyType="HeatSource",
    redefinitions=['force_value'],
    tip="A source or sink of heat flux.")


reg.eqnInfo(equations=[problem.HeatBalanceEquation])
