# This file was created automatically by SWIG.
import thermalexpansionc
from ooflib.SWIG.engine.properties import PropertyPtr
from ooflib.SWIG.engine.symmmatrix import SymmMatrix3Ptr
class IsotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsotropicThermalExpansion instance at %s>" % (self.this,)
class IsotropicThermalExpansion(IsotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_IsotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1




class AnisotropicThermalExpansionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C AnisotropicThermalExpansion instance at %s>" % (self.this,)
class AnisotropicThermalExpansion(AnisotropicThermalExpansionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermalexpansionc.new_AnisotropicThermalExpansion,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: thermalexpansion.spy,v $
# $Revision: 1.7 $
# $Author: langer $
# $Date: 2010-11-10 22:34:18 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov. 


from ooflib.SWIG.engine import symmmatrix
from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Isotropic', IsotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",200,
    [parameter.FloatParameter('alpha', 1.0,
                              tip="Thermal expansion coefficient."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Isotropic thermal expansion')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Triclinic',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",210,
    [symmmatrix.TriclinicRank2TensorParameter(
            'alpha',
            symmmatrix.TriclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter(
            'T0', 0.0,
## TODO: Why does this have a different tip than the rest of the T0's
## in this file?
            tip="Stress free temperature. Sometimes referred to as the deposition temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Triclinic thermal expansion')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature], 
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Monoclinic',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",209,
    [symmmatrix.MonoclinicRank2TensorParameter(
            'alpha',
            symmmatrix.MonoclinicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Monoclinic thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Orthorhombic',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",208,
    [symmmatrix.OrthorhombicRank2TensorParameter(
            'alpha',
            symmmatrix.OrthorhombicRank2Tensor(xx=1.0, yy=1.0, zz=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Orthorhombic thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Tetragonal',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",207,
    [symmmatrix.TetragonalRank2TensorParameter(
            'alpha',
            symmmatrix.TetragonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Tetragonal thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Trigonal',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",206,
    [symmmatrix.TrigonalRank2TensorParameter(
            'alpha',
            symmmatrix.TrigonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Trigonal thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Hexagonal',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",205,
    [symmmatrix.HexagonalRank2TensorParameter(
            'alpha',
            symmmatrix.HexagonalRank2Tensor(xx=1.0, zz=0.5),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Hexagonal thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])

#########

reg = PropertyRegistration(
    'Couplings:ThermalExpansion:Anisotropic:Cubic',
    AnisotropicThermalExpansion,
    "ooflib.SWIG.engine.property.thermalexpansion.thermalexpansion",204,
    [symmmatrix.CubicRank2TensorParameter(
            'alpha',
            symmmatrix.CubicRank2Tensor(xx=1.0),
            tip="Thermal expansion tensor."),
     parameter.FloatParameter('T0', 0.0, tip="Stress free temperature.")],
    outputs=["Strain", "Energy"],
    redefinitions=['flux_matrix', 'flux_offset'],
    propertyType="ThermalExpansion",
    tip='Cubic thermal expansion.')

reg.fluxInfo(fluxes=[problem.Stress], fields=[problem.Temperature],
             time_derivs=[0])
