# -*- python -*-
# $RCSfile: filenameparam.py,v $
# $Revision: 1.3 $
# $Author: langer $
# $Date: 2009-03-20 15:42:00 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from ooflib.common import enum
from ooflib.common.IO import parameter

class FileNameParameter(parameter.StringParameter):
    def __init__(self, name, value=None, default="", tip=None, ident=None):
        self.ident = ident
        parameter.StringParameter.__init__(self, name, value, default, tip)

class WriteFileNameParameter(FileNameParameter):
    action='w'

class ReadFileNameParameter(FileNameParameter):
    action='r'

class WriteMode(enum.EnumClass("w", "a")):
    pass

class WriteModeParameter(enum.EnumParameter):
    def __init__(self, name, value=None, default=None, tip=None):
        enum.EnumParameter.__init__(self, name, WriteMode, value, default, tip)

class OverwriteParameter(parameter.BooleanParameter):
    pass

